# -*- coding: utf-8 -*-
"""
Created on Sun Nov 24 22:15:09 2013

@author: bercherj
"""
# Pour ne pas s'embêter avec les divisions
from __future__ import division
from __future__ import print_function

import scipy
from scipy.signal import lfilter  
from scipy.signal import hann  

# On aura besoin des fonctions fft
from numpy.fft import fft, ifft

def dirac(n):
    """ dirac(n):
    Rend une impulsion de Dirac de longueur n """
    d=zeros(n)
    d[0]=1
    return d

def rectpulse(x):
    """rectpulse(x): \n
    Renvoie un ndarray contenant un train d'impulsions\n
    rectangulaires, de période 2pi"""
    return sign(sin(x))    

# une fonction utilitaire
def freq(N,Fe=1):
    """ Retourne un vecteur de fréquences normalisées 
    entre -0.5 et 0.5 sur N points """
    return (arange(N)/N-1/2)*Fe


def sinc(x):
    x=array(x)
    z=[sin(n)/n if n!=0 else 1 for n in x]
    return array(z)

def repeat(x,n):
    u""" repeat(x,n) -- x ndarray, n integer 
    Répète n fois la séquence x """
    return array([list(x)*n]).flatten()

def echant(x,step):
    z=zeros(x.shape)
    z[0:len(x):step]=x[0:len(x):step]
    return z

